#ifndef __GBDL_H
#define __GBDL_H

#include <iostream>
#include <map>
#include <list>
#include <queue>
#include <assert.h>

using namespace std;

extern "C" {
#include <gb_graph.h>
#include <gb_basic.h>
#include <gb_books.h>
#include <gb_lisa.h>
#include <gb_econ.h>
#include <gb_games.h>
#include <gb_miles.h>
#include <gb_gates.h>
#include <gb_plane.h>
#include <gb_raman.h>
#include <gb_rand.h>
#include <gb_roget.h>
#include <gb_words.h>
#include <string.h>
}


struct stringLesser
{
  bool operator() (char *x, char *y) const
  {
    if (strcmp(x,y) < 0) {
      return true;
    }
    else {
      return false;
    }
  }
};
/*
struct VertexExpression {
public:
  VExprType
}

class PrintPair {
public:
  PrintPair() {}
  

private:
  SymbolTable sym;
}
*/

typedef map< char *, Graph *, stringLesser > SymbolTable;

typedef SymbolTable::value_type StringGraphPair;

typedef SymbolTable::iterator SymIter;

extern int lines_parsed;

// BUG-FIX: bison[1.24] fails to prototype its scanner interface yylex().
extern "C" int gbdlyylex();

// BUG-FIX: bison[1.24] fails to prototype its external error output
//          interface yyerror(), although it makes use of it.
extern "C" void gbdlyyerror(const char*);

extern char * gbdlyytext;
#endif
