#include<iostream>
#include<stdlib.h>
#include<sys/times.h>

using namespace std;

int main(int argc, char **argv)
{
   if(argc != 4)
   {
      cerr << "gen-2qbfEAdnf #E-vars #A-vars #conjuncts" << endl;
      exit(1);
   }

   unsigned num_Evars = atoi(argv[1]);
   unsigned num_Avars = atoi(argv[2]);
   unsigned num_conjuncts = atoi(argv[3]);

   if((num_Evars < 1) || (num_Avars < 2) || (num_conjuncts < 1))
   {
      cerr << "Provide greater values for arguments!" << endl;
      exit(1);
   }

   cerr << "gen-2qbfEAdnf #E-vars = " << num_Evars
                   << "   #A-vars = " << num_Avars
                   << "   #conjuncts = " << num_conjuncts << endl;

   tms tms;
   srandom(times(&tms));

   for(unsigned i = 0; i < num_Evars; i++)
   {
      cout << "exists(e" << i << ")." << endl;
   }
   for(unsigned i = 0; i < num_Avars; i++)
   {
      cout << "forall(a" << i << ")." << endl;
   }

   for(unsigned i = 0; i < num_conjuncts; i++)
   {
      unsigned v[3];
      unsigned pos[3];

      cout << "conjunct(";

      for(unsigned j = 0; j < 3; j++)
      {
         v[j] = random() % (num_Evars + num_Avars);

         // there must be at least two universal variables -
         // required in Model A
         // (Gent and Walsh, "The QSAT Phase Transition", 16th AAAI, 1999)
         //
         if(((j == 1) && (v[0] < num_Evars)) ||
            ((j == 2) && ((v[0] < num_Evars) || (v[1] < num_Evars))))
         {
            v[j] = num_Evars + random() % num_Avars;
         }

         pos[j] = random() % 2;

         if(pos[j])
         {
            if(v[j] < num_Evars)
            {
               cout << "e" << v[j];
            }
            else
            {
               cout << "a" << (v[j] - num_Evars);
            }
         }
         else cout << "true";

         cout << ", ";
      }

      for(unsigned j = 0; j < 3; j++)
      {
         if(! pos[j])
         { 
            if(v[j] < num_Evars)
            {
               cout << "e" << v[j];
            }
            else
            {
               cout << "a" << (v[j] - num_Evars);
            }
         }
         else cout << "false";

         if(j < 2) cout << ", ";
      }

      cout << ")." << endl;
   }

   return 0;
}

