#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec tclsh $0 ${1+"$@"}

# Generate a ladder graphs with <int> levels, i.e., 2*<int> nodes.
#
# Written by Wolfgang Faber.

proc gen {x} {
    
    set i 1
    
    for {set i 1} {$i < $x} {incr i} {
	puts "edge([expr 2*$i], [expr 2*($i+1)]). edge([expr 2*$i], [expr 2*$i+1]). edge([expr 2*$i+1], [expr 2*($i+1)+1])."
    }

    if {$i == $x} then {
	puts "edge( [expr 2*$i], [expr 2*$i+1])."
    }
}

if {$argc > 1 || [scan $argv "%d%s" dummy1 dummy2] != 1} then {
    puts "Usage: ladder <int>"
} else {
    gen $argv
}

