//
// By Christoph Koch.

#include<iostream.h>
#include<stdlib.h>
#include<assert.h>


int main(int argc, char **argv)
{
   // in reality, the assignment of these oids to
   unsigned oid = 0, su_id=0;

   unsigned c_jmax_module = 10;
   unsigned c_imax_submodule = 5;
   bool include_subunits = true;

   extern char *optarg;
   extern int optind;
   int c, errflg = 0;

   while ((c = getopt(argc, argv, "im:s:")) != EOF)
        switch (c)
   {
      case 'm': // set the number of submodules in a module to 4 or 5
                // times atoi(optarg); in reality, c_jmax_module is 10.
         if(atoi(optarg) >= 1)
            c_jmax_module = atoi(optarg);
         else
            cerr << "Error! Using default value for c_jmax_module." << endl;
         break;
      case 's': // set the number of subunits in a submodule to 2 times
                // atom(optarg); in reality, c_imax_submodule is 5.
         if(atoi(optarg) >= 1)
            c_imax_submodule = atoi(optarg);
         else
            cerr << "Error! Using default value for c_imax_submodule." << endl;
         break;
      case 'i': // don't create a subunit layer -> the problem becomes easier.
         include_subunits = false;
         break;
      case '?': errflg++; break;
      default:
         assert(0);
   }
   if(optind != argc) errflg++;

   if(errflg)
   {
      cerr << "USAGE: " << argv[0]
           << " [-m c_jmax_module] [-s c_imax_submodule]" << endl;
      exit(1);
   }


//   cout << "part_definition(def_supermodule, supermodule)" << endl;

   for(unsigned i = 0; i < 1; i++) // supermodules
   {
      cout << "imax(supermodule_" << i+1 << ", 4)." << endl;
      cout << "jmax(supermodule_" << i+1 << ", 1)." << endl;

      for(unsigned j = 0; j < 4; j++)
      {
//         cout << "part_definition(def_module" << i+1 << ", module)" << endl;

         cout << "pcm(module" << j+1 << "_" << i+1 << ", supermodule_" << i+1
              << ", " << j << ", 0)." << endl;

         // a supermodule consists of four modules, the first of which consists
         // of 5 times 10 submodules while the others consist of 4 times 10.
         unsigned from_k, to_k;
         if(j==0) { from_k=1; to_k=5; }
         if(j==1) { from_k=6; to_k=9; }
         if(j==2) { from_k=10; to_k=13; }
         if(j==3) { from_k=14; to_k=17; }

         cout << "imax(module" << j+1 << "_" << i+1 << ", " << to_k-from_k+1
              << ")." << endl;
         cout << "jmax(module" << j+1 << "_" << i+1 << ", "
              << c_jmax_module << ")." << endl;

         for(unsigned k = from_k; k <= to_k; k++)
         {
            for(unsigned l = 0; l < c_jmax_module; l++)
            {
               cout << "pcm(submodule" << k << "_" << oid++ << ", module"
                    << j+1 << "_" << i+1 << ", " << k-from_k << ", " << l
                    << ")." << endl;

               if(include_subunits)
               {
               cout << "imax(submodule" << k << "_" << oid-1 << ", "
                    << c_imax_submodule << ")."
                    << endl;
               cout << "jmax(submodule" << k << "_" << oid-1 << ", 2)."
                    << endl;

               for(unsigned m = 0; m < c_imax_submodule; m++) 
               {
                  for(unsigned n = 0; n < 2; n++)
                  {
                     const char lr[2] = { 'l', 'r' };

                     cout << "pcm(subunit" << k << lr[n] << "_" << su_id++
                          << ", submodule" << k << "_" << (oid-1)
                          << ", " << m << ", " << n << ")." << endl;
                  }
               }
               }
            }
         }
      }
   }

   if(include_subunits)
      cout << "viewpoint_definition(subunit_vp, supermodule_1, 3)." << endl;
   else
      cout << "viewpoint_definition(submodule_vp, supermodule_1, 2)." << endl;

   return 0;
}
