/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include <vector>

#include "Aggregate.h"
#include "Literal.h"
//#include "Atom.h"

ostream&
operator<<(
    ostream & out,
    const Aggregate& aggregate )
{
//    out << "(aggr_id " << aggregate.id << ") ";
    if( aggregate.type == SUM_ID )
        out << "#sum{ ";
    else
        out << "#count{ ";
    unsigned int i = 0;
    for( ; i < aggregate.literalsInTheAggregate.size() - 1; i++ )
    {
        out << "<" << aggregate.literalsValues[ i ] << ":" << aggregate.literalsInTheAggregate[ i ] << ">,";
    }

    out << "<" << aggregate.literalsValues[ i ] << ":" << aggregate.literalsInTheAggregate[ i ] << "> } >= " << aggregate.minGuard;
}

Aggregate::Aggregate(
    unsigned int i,
    unsigned int minG,
    unsigned int maxG,
    unsigned int s,
    AggregateType t ) : id( i ), minGuard( minG ), maxGuard( maxG ), type( t ), currentValue( 0 ), maxPossibleValue( 0 ), leftWatch( 0 ), rightWatch( s - 1 )
{
    literalsInTheAggregate.reserve( s );
    literalsValues.reserve( s );
}