/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/*
 * File:   AggregateAtomDoubleGuards.h
 * Author: Carmine Dodaro
 *
 * Created on 22 June 2012, 17.25
 */

#ifndef _AGGREGATE_ATOM_DOUBLE_GUARDS_H
#define	_AGGREGATE_ATOM_DOUBLE_GUARDS_H

#include <cassert>

#include "AggregateAtomGreater.h"

class AggregateAtomDoubleGuards : public AggregateAtomGreater
{
    public:
        inline AggregateAtomDoubleGuards( AtomId id, string atomName );
        virtual functionPointer getPropagationFunction();        
        
};

AggregateAtomDoubleGuards::AggregateAtomDoubleGuards(
    AtomId id, 
    string atomName ) : AggregateAtomGreater( id, atomName )
{
}

#endif