/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include "ChoiceRule.h"
#include "ProgramBuilder.h"

bool 
ChoiceRule::isRuleActiveForAtom( 
    AtomId ) const
{
    return isActiveForAtom();
}

bool 
ChoiceRule::isWaspRule() const
{
    return false;
}

void
ChoiceRule::print()
{
    cout << *this << endl;
}

Literal& 
ChoiceRule::getRuleBodyLiteral( 
    unsigned int position )
{
    return getBodyLiteral( position );
}

unsigned int
ChoiceRule::getSize() const
{
    return getNumberOfLiteralsInTheBody();
}