/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   LearnedWaspRuleFromModel.h
 * Author: Carmine Dodaro
 *
 * Created on 24 January 2013, 11.37
 */


#ifndef _LEARNEDWASPRULEFROMMODEL_H
#define	_LEARNEDWASPRULEFROMMODEL_H

#include "LearnedWaspRule.h"

class LearnedWaspRuleFromModel : public LearnedWaspRule
{
    public:
        inline LearnedWaspRuleFromModel( unsigned int size );
        virtual bool isLocked() const;
        virtual bool isLearnedFromModel() const;
};

LearnedWaspRuleFromModel::LearnedWaspRuleFromModel(
    unsigned int size ) : LearnedWaspRule( size )
{
}

#endif	/* _LEARNEDWASPRULEFROMMODEL_H */