/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   Rule.h
 * Author: Carmine Dodaro
 *
 * Created on 8 February 2013, 11.51
 */

#ifndef _RULE_H
#define	_RULE_H

#include "Constants.h"

class Literal;
class Rule
{
    public:
        virtual bool isRuleActiveForAtom( AtomId ) const = 0;
        virtual bool isWaspRule() const = 0;
        virtual void print() = 0;
        virtual Literal& getRuleBodyLiteral( unsigned int position ) = 0;
        virtual unsigned int getSize() const = 0;
};

#endif	/* _RULE_H */