/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/*
 * File:   Util.h
 * Author: Carmine Dodaro
 *
 * Created on 11 Aprile 2012, 11.25
 */
#ifndef _WASPUTIL_H
#define	_WASPUTIL_H
#include "Constants.h"
#include <cstdlib>
using namespace std;

class Util
{
    public:
        static unsigned int computeSignature( const int* atoms, unsigned int size )
        {
            unsigned tmp = 0;

            for( int i = 0; i < size; i++ )
            {
                tmp = tmp | getHashCode( abs( atoms[ i ] ) );
            }

            return tmp;
        }

        static unsigned int computeSignature( AtomId atom )
        {
            unsigned tmp = 0;
            tmp = tmp | getHashCode( atom );
            return tmp;
        }

    private:
        static unsigned int getHashCode( AtomId atomId ){ return atomId % 64; }
};

#endif