/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include "WaspRule.h"

//int
//WaspRule::currentlyWatched(
//    AtomId atomId ) const
//{
//    if( literals[ rightWatch ].getAtomId() == atomId )
//        return WATCHED_BY_RIGHT_WATCH;
//    else if( literals[ leftWatch ].getAtomId() == atomId )
//        return WATCHED_BY_LEFT_WATCH;
//    else
//        return NOT_WATCHED;
//}

bool
WaspRule::isLearned() const
{
    return false;
}

WaspRule::~WaspRule()
{
}

bool
WaspRule::isActiveForAtom(
    AtomId atomId ) const
{
    if( isSatisfiedCannotSupport() )
        return false;
    
    if( isSatisfiedCanSupport() )
    {
        AtomId firstFalseLiteral = getIdFirstFalseLiteral();
        assert( getIdSecondFalseLiteral() == 0 );
        return ( atomId == firstFalseLiteral );
    }
    
    return true;    
}

bool
WaspRule::isRuleActiveForAtom(
    AtomId atomId ) const
{
    return isActiveForAtom( atomId );
}

bool 
WaspRule::isWaspRule() const
{
    return true;
}

void
WaspRule::print()
{
    cout << *this << endl;
}

Literal&
WaspRule::getRuleBodyLiteral( 
    unsigned int position )
{
    return getBodyLiteral( position );
}

unsigned int
WaspRule::getSize() const
{
    return getNumberOfLiteralsInTheBody();
}