/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include "WaspRuleContainer.h"

#include "WaspRule.h"

void 
WaspRuleContainer::remove( 
    WaspRule* element )
{
    assert( !empty() );
    assert( exists( element ) );

    swap( element, back() );
    
    pop_back();
    position.erase( element );
}
    
void 
WaspRuleContainer::swap( 
    WaspRule* element1, 
    WaspRule* element2 )
{
    unsigned int& pos1 = position[ element1 ];
    unsigned int& pos2 = position[ element2 ];

    WaspRule* tmp = this->at( pos1 );
    this->at( pos1 ) = this->at( pos2 );
    this->at( pos2 ) = tmp;

    unsigned int tmp2 = pos1;
    pos1 = pos2;
    pos2 = tmp2;
}