/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   BerkminHeuristicBalancedMO.h
 * Author: Carmine Dodaro
 *
 * Created on 07 December 2012, 18.43
 */

#ifndef _BERKMINHEURISTICBALANCEDMO_H
#define	_BERKMINHEURISTICBALANCEDMO_H

#include <cassert>
#include "../Constants.h"
#include "BerkminHeuristic.h"

typedef unsigned int HEURISTIC_TYPE;

class Atom;

class BerkminHeuristicBalancedMO : public BerkminHeuristic
{
    public:
        inline BerkminHeuristicBalancedMO( ModelGenerator* mg, unsigned int atomsSize );        
        
    protected:
        virtual bool pickLiteralWithActivity();        
        bool higherGlobalCounterBalancedMO();      
};

BerkminHeuristicBalancedMO::BerkminHeuristicBalancedMO(
    ModelGenerator* mg, 
    unsigned int atomsSize ) : BerkminHeuristic( mg, atomsSize )
{
}

#endif /* _BERKMINHEURISTICBALANCEDMO_H */