/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   BerkminHeuristicLimitedActivity.h
 * Author: Carmine Dodaro
 *
 * Created on 04 March 2013, 17.32
 */

#ifndef _BERKMINHEURISTICLIMITEDACTIVITY_H
#define	_BERKMINHEURISTICLIMITEDACTIVITY_H

#include <cassert>
#include "../stl/List.h"
#include "../Constants.h"
#include "../DecisionHeuristic.h"
#include "BerkminHeuristic.h"

typedef unsigned int HEURISTIC_TYPE;

class Atom;

class BerkminHeuristicLimitedActivity : public BerkminHeuristic
{
    public:
        inline BerkminHeuristicLimitedActivity( ModelGenerator* mg, unsigned int atomsSize );
        virtual ~BerkminHeuristicLimitedActivity();
        
        virtual bool onRestart( unsigned int numberOfRestarts );
        
    protected:
        virtual bool pickLiteralWithActivity();
        
    private:
        unsigned int countOfActivityHeuristic;
};


BerkminHeuristicLimitedActivity::BerkminHeuristicLimitedActivity( 
    ModelGenerator* mg, 
    unsigned int as ) : BerkminHeuristic( mg, as )
{
    countOfActivityHeuristic = 0;
}

#endif /* _BERKMINHEURISTICLIMITEDACTIVITY_H */
