/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   BerkminHeuristicTwoLight.h
 * Author: Carmine Dodaro
 *
 * Created on 05 December 2012, 15.20
 */

#ifndef _BERKMINHEURISTICTWOLIGHT_H
#define	_BERKMINHEURISTICTWOLIGHT_H

#include "BerkminHeuristicTwo.h"

class BerkminHeuristicTwoLight : public BerkminHeuristicTwo
{
    public:
        inline BerkminHeuristicTwoLight( ModelGenerator* mg, unsigned int atomsSize );
        virtual bool onRestart( unsigned int numberOfRestarts );
        virtual void choosePolarity( Atom& );
        
    protected:
        bool haveToCalculateCounters;                
};

BerkminHeuristicTwoLight::BerkminHeuristicTwoLight( 
    ModelGenerator* mg, 
    unsigned int atomsSize ) : BerkminHeuristicTwo( mg, atomsSize ), haveToCalculateCounters( true )
{
}

#endif /* _BERKMINHEURISTICTWOLIGHT_H */