/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   BerkminHeuristicWeakConstraints.h
 * Author: Carmine Dodaro
 *
 * Created on 23 March 2013, 19.47s
 */

#ifndef _BERKMINHEURISTICWEAKCONSTRAINTS_H
#define	_BERKMINHEURISTICWEAKCONSTRAINTS_H

#include <cassert>
#include "../Constants.h"
#include "BerkminHeuristic.h"

class BerkminHeuristicWeakConstraints : public BerkminHeuristic
{
    public:
        inline BerkminHeuristicWeakConstraints( ModelGenerator* mg, unsigned int atomsSize );
        virtual ~BerkminHeuristicWeakConstraints();
        
        virtual void makeAChoice();
        
    protected:
        virtual bool makeAChoiceUsingWeakConstraints();
};


BerkminHeuristicWeakConstraints::BerkminHeuristicWeakConstraints( 
    ModelGenerator* mg, 
    unsigned int atomsSize ) : BerkminHeuristic( mg, atomsSize )
{
}

#endif /* _BERKMINHEURISTICWEAKCONSTRAINTS_H */
