/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/*  
 * File:   MixedHeuristicPrelookaheadRestart.h
 * Author: Carmine Dodaro
 *
 * Created on 11 December 2012, 15.08
 */

#ifndef _MIXEDHEURISTICPRELOOKAHEADRESTART_H
#define	_MIXEDHEURISTICPRELOOKAHEADRESTART_H

#include <cassert>
#include "../Constants.h"
#include "MixedHeuristicPrelookahead.h"

class MixedHeuristicPrelookaheadRestart : public MixedHeuristicPrelookahead
{
    public:
        inline MixedHeuristicPrelookaheadRestart( ModelGenerator* mg, DecisionHeuristic* h1, DecisionHeuristic* h2 );
        
        virtual bool onRestart( unsigned int numberOfRestarts );
        virtual bool onInit();             
};

MixedHeuristicPrelookaheadRestart::MixedHeuristicPrelookaheadRestart(
    ModelGenerator* mg,
    DecisionHeuristic* h1,
    DecisionHeuristic* h2 ) : MixedHeuristicPrelookahead( mg, h1, h2 )
{    
}

#endif /* _MIXEDHEURISTICPRELOOKAHEADRESTART_H */