/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

/* 
 * File:   PrelookaheadHeuristicLight.h
 * Author: Carmine Dodaro
 *
 * Created on 07 December 2012, 11.25
 */

#ifndef _PRELOOKAHEADHEURISTICLIGHT_H
#define	_PRELOOKAHEADHEURISTICLIGHT_H

#include <list>
#include <unordered_set>
using namespace std;
#include "../Constants.h"
#include "PrelookaheadHeuristic.h"

class ModelGenerator;

class PrelookaheadHeuristicLight : public PrelookaheadHeuristic
{
    public:
        PrelookaheadHeuristicLight( ModelGenerator* mg, unsigned int atomsSize );

    protected:
        virtual bool lookaheadInitial();
        virtual bool onInit();
        
        list< pair< AtomId, unsigned int > > atomsOrderedByMO;        
};

#endif /* _PRELOOKAHEADHEURISTICLIGHT_H */