/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include "QueryCompetitionOutputBuilder.h"
#include "../Constants.h"
#include "../Program.h"

extern int EXIT_CODE;

void 
QueryCompetitionOutputBuilder::onAnswerSetFound( 
    Interpretation&, 
    Program& program )
{
    assert( program.hasQuery() );
    EXIT_CODE = 20;
    cout << ANSWER << endl;
    cout << QUERY_FALSE_OUTPUT << endl;
}

void
QueryCompetitionOutputBuilder::onProgramIncoherent()
{
    EXIT_CODE = 10;
    cout << ANSWER << endl;
    cout << QUERY_TRUE_OUTPUT << endl;
}