/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include "SilentOutputBuilder.h"

#include "../Interpretation.h"
#include "../Program.h"
#include "../Atom.h"

void 
SilentOutputBuilder::onAnswerSetFound( 
    Interpretation& interpretation, 
    Program& program )
{
    unsigned int size = program.getNumberOfAtoms();
    cout << "{";
    int i = 1;
    for( ; i < size; i++ )
    {
        Atom& atom = program.getAtom( i );
        if( interpretation.isTruePropagated( i ) && !atom.isHidden() )
        {
            cout << atom;
            break;
        }
    }
    
    i++;
    
    for( ; i < size; i++ )
    {
        Atom& atom = program.getAtom( i );
        if( interpretation.isTruePropagated( i ) && !atom.isHidden() )
        {
            cout << ", " << atom;            
        }
    }

    cout << "}"  << endl;
}

void
SilentOutputBuilder::onProgramIncoherent()
{
}