/*
*
*  Copyright 2013 Mario Alviano, Carmine Dodaro, Wolfgang Faber, Nicola Leone, Francesco Ricca, and Marco Sirianni.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#include "ThirdCompetitionOutputBuilder.h"
#include "../Program.h"
#include "../ModelGenerator.h"
#include "../Constants.h"

void
ThirdCompetitionOutputBuilder::onAnswerSetFound(
    Interpretation& interpretation,
    Program& program )
{
    cout << ANSWER_THIRD_COMPETITION << endl;
    unsigned int size = interpretation.getSize();
    unsigned int i = 1;
    for( ; i < size; i++ )
    {
        Atom& atom = program.getAtom( i );
        if( interpretation.isTruePropagated( i ) && !atom.isHidden() )
        {
            cout << atom << ". ";
            break;
        }
    }
    i++;
    for( ; i < size; i++ )
    {
        Atom& atom = program.getAtom( i );
        if( interpretation.isTruePropagated( i ) && !atom.isHidden() )
        {
            cout << atom << ". ";
        }
    }
    
    cout << endl;
}

void
ThirdCompetitionOutputBuilder::onProgramIncoherent()
{
    cout << NOMODEL_COMPETITION_OUTPUT << endl;
}